       ORG 30000
       LD   HL,NEWVEC
       LD   (VECTOR),HL ;alter vector
       LD   BC,0
       RET
NEWVEC ADD  A,206
       CP   "*"
       JP   NZ,#01F0
       RST  #10
       DEFW #20 ;next char
       OR   #20 ;make it l.c.
       CP   "l"
       JP   NZ,#0028 ;error if not L
       RST  #10
       DEFW #20 ;next char
       CALL #061E ;eval BC
       CALL #05B7 ;check end
       CALL WATROM ;redo to suit ROM
       CALL FIND
       JP   #05C1
;
;modify routine for different ROMs
WATROM LD   HL,OLDROM
       LD   A,(#16DA)
       CP   #FF
       JR   Z,YESOLD
       LD   HL,NEWROM ;to suit new ROM
YESOLD LD   B,5 ;number of CALLs to alter
REDOLP LD   E,(HL)
       INC  HL
       LD   D,(HL) ;DE=CALL+1
       INC  HL
       LD   A,(HL)
       LD   (DE),A
       INC  HL
       LD   A,(HL)
       INC  DE
       LD   (DE),A ;alter CALL
       INC  HL
       DJNZ REDOLP
       RET
;data table for old ROM
OLDROM DEFW L1+1,#0FEB ;CREATM
       DEFW L2+1,#17F7 ;MOTOR
       DEFW NXHDBF+1,#12C4 ;NEXTHD
       DEFW L4+1,#18A9 ;RDBYTS
       DEFW L5+1,#12A9 ;CLOSEM
;data table for new ROM
NEWROM DEFW L1+1,#10A5 ;CREATM
       DEFW L2+1,#1532 ;MOTOR
       DEFW NXHDBF+1,#13A9 ;NEXTHD
       DEFW L4+1,#15EB ;RDBYTS
       DEFW L5+1,#138E ;CLOSEM
;FIND
;finds all duff sectors
FIND   CALL FINDZ$ ;check Z$ is there
L1     CALL CREATM ;create M area
       CALL FINDZ$
       LD   (FMARK),HL ;zero pointer
       LD   A,(IX+25)
L2     CALL MOTOR ;switch on
       LD   HL,50
       LD   (SECTOR),HL ;minimum 50 sectors
FLOOP  CALL NXHDBF ;next header & buffer
       PUSH AF
       LD   A,(IX+41) ;SECNO
       ADD  A,3
       LD   HL,SECTOR
       CP   (HL)
       JR   C,LESS ;skip if less
       LD   (HL),A ;else store new sector length
LESS   POP  AF
       JR   Z,NEXT ;if not used
       JR   C,ISBAD ;if 1st checksum fails
       LD   BC,#0200
       PUSH IX
       POP  HL
       LD   DE,#0052
       ADD  HL,DE
       CALL CHKSUM
       JR   Z,ISBAD ;if 2nd checksum OK too
       SCF  ;if 2nd bad
ISBAD  EX   AF,AF' ;save good/bad flag
       LD   HL,(FMARK)
       PUSH IX
       LD   B,10
LPNAM  LD   A,(IX+71)
       LD   (HL),A ;copy name into free area
       INC  HL
       INC  IX
       DJNZ LPNAM
       POP  IX
       LD   A,(IX+68)
       LD   (HL),A ;store RECNUM
       INC  HL
       LD   A,(IX+41)
       LD   (HL),A ;store HDNUM
       INC  HL
       LD   B,(IX+67)
       SRA  B ;shift to lose bit 0
       RES  7,B
       EX   AF,AF'
       JR   NC,CHKOK2
       SET  7,B ;if checksum failed
CHKOK2 LD   (HL),B ;store flag
       INC  HL
       LD   (FMARK),HL
NEXT   LD   HL,SECTOR+1
       LD   A,(HL)
       INC  A
       LD   (HL),A ;inc count
       DEC  HL
       CP   (HL)
       JR   C,FLOOP ;if more to do
       RES  0,(IX+24) ;ensure read file
       LD   HL,(VARS)
       PUSH HL
L5     CALL CLOSEM ;close area & motor off
       POP  DE
       LD   HL,(VARS)
       AND  A
       SBC  HL,DE ;HL=change in VARS
       LD   A,4
       OUT  (#FE),A ;green border while sorting
       LD   DE,(FMARK)
       ADD  HL,DE ;decrease FMARK suitably
       LD   (FMARK),HL
;THE BUBBLE SORT
;(no prizes for speed)
LENGTH EQU  13 ;=items in each record
SORT   XOR  A
       EX   AF,AF' ;zero sort flag
       LD   HL,(FMARK)
       PUSH HL
       POP  IX
       LD   (IX+11),#FF ;insert end marker
       LD   DE,-2*LENGTH
       ADD  HL,DE
       EX   DE,HL
       LD   HL,LENGTH
       ADD  HL,DE
       EX   DE,HL ;DE=lowest element, HL=1 above
STLP   PUSH HL
       PUSH DE
       CALL FINDZ$
       POP  DE
       AND  A
       SBC  HL,DE
       POP  HL ;Z if at start
       JR   NC,ENDED
       JR   NZ,NENDS
ENDED  EX   AF,AF' ;end of pass
       AND  A
       JR   NZ,SORT ;if nor finished
       LD   A,(BORDCR)
       RRCA
       RRCA
       RRCA
       AND  #07
       OUT  (#FE),A ;restore border colour
       RET  ;then exit
NENDS  PUSH HL
       PUSH DE
       RST  #10
       DEFW #1F54 ;check break
       JR   C,NBRK
       LD   (IY+0),#14 ;force Break error
       RST  #28
NBRK   LD   B,LENGTH
ORDCHK LD   A,(DE)
       CP   (HL)
       JR   C,SWAP ;if not in order
       JR   NZ,NOTSAM ;if different
       INC  DE
       INC  HL
       DJNZ ORDCHK ;do all chars
NOTSAM POP  DE
       POP  HL
NXTBUB EX   DE,HL ;move DE up
       LD   BC,-LENGTH
       ADD  HL,BC ;move HL up
       JR   STLP
;
SWAP   POP  DE
       POP  HL
       LD   BC,LENGTH
       ADD  HL,BC
       EX   DE,HL
       ADD  HL,BC
       EX   DE,HL
       LD   B,LENGTH
SWLP   DEC  HL
       DEC  DE
       LD   A,(DE)
       LD   C,(HL)
       LD   (HL),A
       LD   A,C
       LD   (DE),A ;swap bytes
       DJNZ SWLP ;do all chars
       EX   AF,AF'
       LD   A,1 ;show 'sorted'
       EX   AF,AF'
       JR   NXTBUB
;
;read next sector
;Z if not used
;else C if check fails
;or NC if check OK
NXHDBF CALL NEXTHD ;next header
       LD   DE,#001B
       ADD  HL,DE
L4     CALL RDBYTS ;read the data
       LD   BC,#000E
       CALL CHKSUM
       JR   Z,CHKOK
       SCF  ;if check fails
       RET
CHKOK  BIT  0,(IX+67)
       JR   NZ,BAD
       LD   A,(IX+67)
       OR   (IX+70)
       AND  2
       RET  Z ;if not used
       LD   A,#FF
       OR   A
       RET  ;if sector OK
BAD    XOR  A
       RET
;
;CHECKSUM CALCULATOR
CHKSUM PUSH HL
       LD   E,0
L134C  LD   A,E
       ADD  A,(HL)
       INC  HL
       ADC  A,1
       JR   Z,L1354
       DEC  A
L1354  LD   E,A
       DEC  BC
       LD   A,B
       OR   C
       JR   NZ,L134C
       LD   A,E
       CP   (HL)
       POP  HL
       RET
;
;FIND Z$
;returns with HL=start of elements in Z$
FINDZ$ LD   HL,(VARS)
VARLP  LD   A,(HL)
       CP   128
       JR   NZ,MORVAR ;if more variables left
       LD   (IY+0),#01
       RST  #28 ;"Variable not found"
MORVAR CP   "Z"+128
       JR   NZ,NOTZ$
       LD   BC,8
       ADD  HL,BC ;skip over other bytes in array
       RET
NOTZ$  RST  #10
       DEFW #19B8 ;get next variable start
       EX   DE,HL
       JR   VARLP ;try again with next one
;CONSTANTS
CREATM EQU  #0FE8
MOTOR  EQU  #17F7
NEXTHD EQU  #12C4
RDBYTS EQU  #18A9
CLOSEM EQU  #12A9
BORDCR EQU  #5C48
VARS   EQU  #5C4B
VECTOR EQU  #5CB7
SECTOR EQU  #5CC9
PRTBC  EQU  #1A1B
FMARK  DEFW 0
TEMPA  DEFB 0
*D+
*L+
       DEFW $-30000
